;	04-06-06
;	Ejemplo 04
;	Luces del Auto fantastico
;	PIC 16f84a
;	MPLAB 7.30
;	PROTEUS 6.9 SP3
;	Veguepic

	LIST	P=16F84A,				; usar PIC 16F84A
	#include <p16f84A.inc>

	__CONFIG _CP_OFF&_PWRTE_ON&_WDT_OFF&_XT_OSC	; code protec		off
							; power up timer	on
							; watchdog		off
							; osc			XT

PDel0	equ	0C
PDel1	equ	0D


	ORG	0
	BSF	STATUS,5				; activa la pagina 1
	MOVLW	B'00000'				; carga 00000 en W
	MOVWF	TRISA					; puerto a todos salidas
	MOVLW	B'00000000'				; carga 00000000 en W
	MOVWF	TRISB					; puerto b todos salidaS
	BCF	STATUS,5				; volvemos a la pagina 0

	MOVLW	B'00000000'				; ponemos a cero el
	MOVWF	PORTB					; el puerto b

INICIO							; etiqueta

	BSF	PORTB,0					; prendemos y apagamos
	CALL	DEMORA					; led por led
	BCF	PORTB,0					; despues trataremos de
							; usar otra funcion
	BSF	PORTB,1
	CALL	DEMORA
	BCF	PORTB,1

	BSF	PORTB,2
	CALL	DEMORA
	BCF	PORTB,2

	BSF	PORTB,3
	CALL	DEMORA
	BCF	PORTB,3

	BSF	PORTB,4
	CALL	DEMORA
	BCF	PORTB,4

	BSF	PORTB,5
	CALL	DEMORA
	BCF	PORTB,5

	BSF	PORTB,6
	CALL	DEMORA
	BCF	PORTB,6

	BSF	PORTB,7
	CALL	DEMORA
	BCF	PORTB,7

	BSF	PORTB,6
	CALL	DEMORA
	BCF	PORTB,6

	BSF	PORTB,5
	CALL	DEMORA
	BCF	PORTB,5

	BSF	PORTB,4
	CALL	DEMORA
	BCF	PORTB,4

	BSF	PORTB,3
	CALL	DEMORA
	BCF	PORTB,3

	BSF	PORTB,2
	CALL	DEMORA
	BCF	PORTB,2

	BSF	PORTB,1
	CALL	DEMORA
	BCF	PORTB,1


	GOTO	INICIO					; va a inicio

;-------------------------------------------------------------
;	La demora a sido generada con el programa PDEL
;	Descripcion: Delay 100000 ciclos - 100 ms
;-------------------------------------------------------------
DEMORA  movlw     .110      ; 1 set numero de repeticion  (B)
        movwf     PDel0     ; 1 |
PLoop1  movlw     .181      ; 1 set numero de repeticion  (A)
        movwf     PDel1     ; 1 |
PLoop2  clrwdt              ; 1 clear watchdog
        clrwdt              ; 1 ciclo delay
        decfsz    PDel1, 1  ; 1 + (1) es el tiempo 0  ? (A)
        goto      PLoop2    ; 2 no, loop
        decfsz    PDel0,  1 ; 1 + (1) es el tiempo 0  ? (B)
        goto      PLoop1    ; 2 no, loop
PDelL1  goto PDelL2         ; 2 ciclos delay
PDelL2  goto PDelL3         ; 2 ciclos delay
PDelL3  clrwdt              ; 1 ciclo delay
        return              ; 2+2 Fin.
;-------------------------------------------------------------

	END						; fin de programa
